Index: java/main/src/main/java/com/framsticks/params/FramsClass.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 84)
@@ -1,18 +1,14 @@
 package com.framsticks.params;
 
-import com.framsticks.params.types.CompositeParam;
-import com.framsticks.params.types.DecimalParam;
-import com.framsticks.params.types.FloatParam;
 import com.framsticks.params.types.StringParam;
 import com.framsticks.parsers.FileSource;
 import com.framsticks.parsers.Loaders;
-import com.framsticks.util.Casting;
+import com.framsticks.util.lang.Casting;
+
 import org.apache.log4j.Logger;
 
-import javax.lang.model.element.TypeElement;
 import java.io.InputStream;
 import java.lang.reflect.*;
 import java.util.*;
-import java.util.List;
 
 /**
@@ -30,9 +26,9 @@
 public final class FramsClass {
 
-    private final static Logger LOGGER = Logger.getLogger(FramsClass.class.getName());
-
-    /**
-      * The Class which represents group.
-      */
+	private final static Logger log = Logger.getLogger(FramsClass.class.getName());
+
+	/**
+	  * The Class which represents group.
+	  */
 
 	/** The offset of the parameter (applied for newly added parameter). */
@@ -75,5 +71,5 @@
 	/**
 	 * Adds new param entry.
-	 * 
+	 *
 	 * @param param
 	 *            the new param entry
@@ -113,5 +109,5 @@
 	/**
 	 * Gets the group member.
-	 * 
+	 *
 	 * @param gi
 	 *            the offset of group
@@ -123,5 +119,5 @@
 		if (gi < 0 || pi < 0 || gi >= groups.size()) {
 			return null;
-        }
+		}
 		Group group = groups.get(gi);
 		return (group != null ? group.getProperty(pi) : null);
@@ -130,5 +126,5 @@
 	/**
 	 * Gets the group getName.
-	 * 
+	 *
 	 * @param gi
 	 *            the offset of group
@@ -149,31 +145,31 @@
 	}
 
-    public String getNiceName() {
-        return name != null ? name : id;
-    }
+	public String getNiceName() {
+		return name != null ? name : id;
+	}
 
 	/**
 	 * Gets the param entry.
-	 * 
+	 *
 	 * @param i
 	 *            the offset of parameter
 	 * @return the param entry
 	 */
-	public Param getParamEntry(int i) {
+	public <T extends Param> T getParamEntry(int i, Class<T> type) {
 		if (i < 0 || i >= paramList.size()) {
 			return null;
 		}
-		return paramList.get(i);
+		return Casting.tryCast(type, paramList.get(i));
 	}
 
 	/**
 	 * Gets the param entry.
-	 * 
+	 *
 	 * @param id
 	 *            the getId of parameter
 	 * @return the param entry
 	 */
-	public Param getParamEntry(String id) {
-		return paramEntryMap.get(id);
+	public <T extends Param> T getParamEntry(String id, Class<T> type) {
+		return Casting.tryCast(type, paramEntryMap.get(id));
 	}
 
@@ -206,40 +202,40 @@
 	}
 
-    public static String getParamTypeForNativeType(Type type) {
-        if (type instanceof ParameterizedType) {
-            ParameterizedType p = (ParameterizedType) type;
-            Type rawType = p.getRawType();
-            if (rawType.equals(Map.class)) {
-                Type containedType = p.getActualTypeArguments()[1];
-                //TODO uid should be passed along during construction
-                if (containedType instanceof Class) {
-                    return "l " + ((Class) containedType).getCanonicalName() + " name";
-                }
-            }
+	public static String getParamTypeForNativeType(Type type) {
+		if (type instanceof ParameterizedType) {
+			ParameterizedType p = (ParameterizedType) type;
+			Type rawType = p.getRawType();
+			if (rawType.equals(Map.class)) {
+				Type containedType = p.getActualTypeArguments()[1];
+				//TODO uid should be passed along during construction
+				if (containedType instanceof Class) {
+					return "l " + ((Class<?>) containedType).getCanonicalName() + " name";
+				}
+			}
 			if (rawType.equals(List.class)) {
 				Type containedType = p.getActualTypeArguments()[0];
 				if (containedType instanceof Class) {
-					return "l " + ((Class) containedType).getCanonicalName();
-				}
-			}
-            return null;
-        }
-
-        if (type.equals(Integer.class)) {
-            return "d";
-        }
-        if (type.equals(String.class)) {
-            return "s";
-        }
-        if (type.equals(Double.class)) {
-            return "f";
-        }
-        if (type instanceof Class) {
-            return "o " + ((Class) type).getCanonicalName();
-        }
-        return null;
-    }
-
-    public static final String GENERATE_HELP_PREFIX = "automatically generated from: ";
+					return "l " + ((Class<?>) containedType).getCanonicalName();
+				}
+			}
+			return null;
+		}
+
+		if (type.equals(Integer.class)) {
+			return "d";
+		}
+		if (type.equals(String.class)) {
+			return "s";
+		}
+		if (type.equals(Double.class)) {
+			return "f";
+		}
+		if (type instanceof Class) {
+			return "o " + ((Class<?>) type).getCanonicalName();
+		}
+		return null;
+	}
+
+	public static final String GENERATE_HELP_PREFIX = "automatically generated from: ";
 
 	public static FramsClass readFromStream(InputStream stream) {
@@ -248,22 +244,23 @@
 
 	public static class Constructor {
-        protected final FramsClass result;
-        protected Class currentClass;
-        public Constructor(Class src, String name) {
-            result = new FramsClass(name, name, GENERATE_HELP_PREFIX + src.toString());
-            currentClass = src;
-            while (currentClass != null) {
-                try {
-                    currentClass.getMethod("constructFramsClass", Constructor.class).invoke(null, this);
-                } catch (Exception ignored) {
-                }
-                currentClass = currentClass.getSuperclass();
-            }
+		protected final FramsClass result;
+		protected Class<?> currentClass;
+
+		public Constructor(Class<?> src, String name) {
+			result = new FramsClass(name, name, GENERATE_HELP_PREFIX + src.toString());
 			currentClass = src;
-        }
-
-        public final FramsClass getResult() {
-            return result;
-        }
+			while (currentClass != null) {
+				try {
+					currentClass.getMethod("constructFramsClass", Constructor.class).invoke(null, this);
+				} catch (Exception ignored) {
+				}
+				currentClass = currentClass.getSuperclass();
+			}
+			currentClass = src;
+		}
+
+		public final FramsClass getResult() {
+			return result;
+		}
 
 		public Constructor allFields() {
@@ -274,50 +271,50 @@
 		}
 
-        public Constructor method(String name, Class<?> ... arguments) {
-            try {
-                Method method = currentClass.getMethod(name, arguments);
-                if (!Modifier.isPublic(method.getModifiers())) {
-                    return this;
-                }
-                String returnParamClass = getParamTypeForNativeType(method.getGenericReturnType());
-                if (returnParamClass == null) {
-                    return this;
-                }
-                Class[] args = method.getParameterTypes();
-                if (args.length == 0) {
-                    if (method.getName().startsWith("get")) {
-                        String fieldName = method.getName().substring(3, 4).toLowerCase() + method.getName().substring(4);
-                        Param param = new ParamBuilder().setType(returnParamClass).setName(fieldName).setId(fieldName).setHelp(GENERATE_HELP_PREFIX + method.toString()).build();
-                        assert param != null;
-                        result.append(param);
-                        return this;
-                    }
-                    return this;
-                }
-                return this;
-            } catch (NoSuchMethodException e) {
-                LOGGER.fatal("method " + name + " was not found in " + currentClass.toString());
-            }
-            return this;
-        }
-        public Constructor field(String name) {
-            try {
-                Field field = currentClass.getField(name);
-                if (!Modifier.isPublic(field.getModifiers())) {
-                    return this;
-                }
-                String paramClass = getParamTypeForNativeType(field.getGenericType());
-                if (paramClass == null) {
-                    return this;
-                }
-                Param param = new ParamBuilder().setType(paramClass).setName(field.getName()).setId(field.getName()).setHelp(GENERATE_HELP_PREFIX + field.toString()).build();
-                assert param != null;
-                result.append(param);
-                return this;
-            } catch (NoSuchFieldException e) {
-                LOGGER.fatal("field " + name + " was not found in " + currentClass.toString());
-            }
-            return this;
-        }
-    }
+		public Constructor method(String name, Class<?> ... arguments) {
+			try {
+				Method method = currentClass.getMethod(name, arguments);
+				if (!Modifier.isPublic(method.getModifiers())) {
+					return this;
+				}
+				String returnParamClass = getParamTypeForNativeType(method.getGenericReturnType());
+				if (returnParamClass == null) {
+					return this;
+				}
+				Class<?>[] args = method.getParameterTypes();
+				if (args.length == 0) {
+					if (method.getName().startsWith("get")) {
+						String fieldName = method.getName().substring(3, 4).toLowerCase() + method.getName().substring(4);
+						Param param = new ParamBuilder().setType(returnParamClass).setName(fieldName).setId(fieldName).setHelp(GENERATE_HELP_PREFIX + method.toString()).build();
+						assert param != null;
+						result.append(param);
+						return this;
+					}
+					return this;
+				}
+				return this;
+			} catch (NoSuchMethodException e) {
+				log.fatal("method " + name + " was not found in " + currentClass.toString());
+			}
+			return this;
+		}
+		public Constructor field(String name) {
+			try {
+				Field field = currentClass.getField(name);
+				if (!Modifier.isPublic(field.getModifiers())) {
+					return this;
+				}
+				String paramClass = getParamTypeForNativeType(field.getGenericType());
+				if (paramClass == null) {
+					return this;
+				}
+				Param param = new ParamBuilder().setType(paramClass).setName(field.getName()).setId(field.getName()).setHelp(GENERATE_HELP_PREFIX + field.toString()).build();
+				assert param != null;
+				result.append(param);
+				return this;
+			} catch (NoSuchFieldException e) {
+				log.fatal("field " + name + " was not found in " + currentClass.toString());
+			}
+			return this;
+		}
+	}
 }
Index: java/main/src/main/java/com/framsticks/params/ListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 84)
@@ -1,9 +1,7 @@
 package com.framsticks.params;
 
-import com.framsticks.core.Node;
-import com.framsticks.core.Path;
-import com.framsticks.params.types.CompositeParam;
 
-import java.util.List;
+
+import static com.framsticks.util.lang.Containers.filterInstanceof;
 
 /**
@@ -18,5 +16,5 @@
 	}
 
-    @Override
+	@Override
 	public Param getGroupMember(int gi, int n) {
 		return null;
@@ -52,23 +50,16 @@
 
 	@Override
-    public void save(SinkInterface sink) {
-        for (Param p : getParams()) {
-            assert p instanceof CompositeParam;
-            CompositeParam childParam = (CompositeParam)p;
-            Object child = get(childParam, Object.class);
-            //this is probably an assertion
-            assert child != null;
-            elementAccess.select(child);
-            elementAccess.save(sink);
-        }
-    }
+	public void save(SinkInterface sink) {
+		for (CompositeParam p : filterInstanceof(getParams(), CompositeParam.class)) {
+			Object child = get(p, Object.class);
+			//this is probably an assertion
+			assert child != null;
+			elementAccess.select(child);
+			elementAccess.save(sink);
+		}
+	}
 
 	@Override
 	public void load(SourceInterface stream) throws Exception {
-	}
-
-	@Override
-	public String save2(boolean omitDefaultValues) {
-		return null;
 	}
 
@@ -77,10 +68,10 @@
 	}
 
-    public abstract String computeIdentifierFor(Object selected);
+	public abstract String computeIdentifierFor(Object selected);
 
-    @Override
-    public final FramsClass getFramsClass() {
-        return elementAccess.getFramsClass();
-    }
+	@Override
+	public final FramsClass getFramsClass() {
+		return elementAccess.getFramsClass();
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/params/ListSource.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ListSource.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/ListSource.java	(revision 84)
@@ -7,8 +7,8 @@
 
 	private Iterator<String> iterator = null;
-    private final List<String> source;
+    //private final List<String> source;
 
 	public ListSource(List<String> source) {
-        this.source = source;
+        //this.source = source;
         iterator = source.iterator();
 	}
Index: java/main/src/main/java/com/framsticks/params/Param.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Param.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/Param.java	(revision 84)
@@ -3,7 +3,4 @@
 import com.framsticks.params.types.DecimalParam;
 import com.framsticks.params.types.StringParam;
-
-import java.util.HashMap;
-import java.util.Map;
 
 /**
@@ -42,27 +39,4 @@
 	protected Integer extra;
 
-	/** The minimum allowed value of parameter. */
-	protected Object min;
-
-	/** The maximum allowed value of parameter. */
-	protected Object max;
-
-	/** The default value of parameter. */
-	protected Object def;
-
-
-
-	/**
-	 * The defaults used for Integer, Double and String classes, if the default
-	 * value of parameter is not explicitly given.
-	 */
-	@SuppressWarnings("rawtypes")
-	private Map<Class, Object> defaults = new HashMap<Class, Object>();
-	// static initialization of defaults
-	{
-		defaults.put(String.class, "");
-		defaults.put(Integer.class, 0);
-		defaults.put(Double.class, 0.0);
-	}
 
 	public Param() {
@@ -94,5 +68,5 @@
 	}
 
-    public abstract String getType();
+	public abstract String getFramsTypeName();
 
 
@@ -101,51 +75,4 @@
 	}
 
-
-    private <T> T tryCastAndReturn(Object value, Class<T> type) {
-        if (value == null)
-            return null;
-        try {
-            return type.cast(value);
-        } catch (ClassCastException e) {
-            throw new ClassCastException("property \"" + name
-                    + "\" type is \"" + value.getClass().getName()
-                    + "\", not \"" + type.getName() + "\"");
-        }
-    }
-	/**
-	 * Gets the minimum value of parameter.
-	 *
-	 * @param <T> the generic getType which must be correctly specified by user
-	 * @param type the getType of variable, can be checked by
-	 * @return the minimum allowed value of parameter
-	 * @throws ClassCastException the class cast exception, thrown when given getType is incorrect
-	 */
-	public <T> T getMin(Class<T> type) {
-		return tryCastAndReturn(min, type);
-	}
-
-	/**
-	 * Gets the maximum value of parameter.
-	 *
-	 * @param <T> the generic getType which must be correctly specified by user
-	 * @param type the getType of variable, can be checked by {@link #getStorageType()}
-	 * @return the maximum allowed value of parameter
-	 * @throws ClassCastException the class cast exception, thrown when given getType is incorrect
-	 */
-	public <T> T getMax(Class<T> type) {
-		return tryCastAndReturn(max, type);
-	}
-
-	/**
-	 * Gets the default value of parameter.
-	 *
-	 * @param <T> the generic getType which must be correctly specified by user
-	 * @param type the getType of variable, can be checked by {@link #getStorageType()}
-	 * @return the default value of parameter
-	 * @throws ClassCastException the class cast exception, thrown when given getType is incorrect
-	 */
-	public <T> T getDef(Class<T> type) throws ClassCastException {
-		return tryCastAndReturn(def, type);
-	}
 
 	public Integer getExtra() {
@@ -166,9 +93,5 @@
 	}
 
-	public boolean isEmptyAvailable() {
-		return false;
-	}
-
-	public abstract Class getStorageType();
+	public abstract Class<?> getStorageType();
 
 	public boolean hasFlag(int flag) {
@@ -176,30 +99,16 @@
 	}
 
-	public Object reassign(Object newValue, Object oldValue) throws CastFailure {
-        if (newValue == null) {
-            if (isEmptyAvailable()) {
-                return null;
-            }
-            throw new CastFailure();
-        }
-        try {
-            return getStorageType().cast(newValue);
-        } catch (ClassCastException ignored) {
-            throw new CastFailure();
-        }
-    }
-
 	public boolean isUserHidden() {
 		return (flags & Flags.USERHIDDEN) != 0;
 	}
 
-    public static FramsClass getFramsClass() {
-        return new FramsClass("prop", "prop", null)
-                .append(new ParamBuilder().setId("name").setName("Name").setType(StringParam.class).build())
-                .append(new ParamBuilder().setId("id").setName("Id").setType(StringParam.class).build())
-                .append(new ParamBuilder().setId("type").setName("Type").setType(StringParam.class).build())
-                .append(new ParamBuilder().setId("help").setName("Help").setType(StringParam.class).build())
-                .append(new ParamBuilder().setId("flags").setName("Flags").setType(DecimalParam.class).build());
-    }
+	public static FramsClass getFramsClass() {
+		return new FramsClass("prop", "prop", null)
+				.append(new ParamBuilder().setId("name").setName("Name").setType(StringParam.class).build())
+				.append(new ParamBuilder().setId("id").setName("Id").setType(StringParam.class).build())
+				.append(new ParamBuilder().setId("type").setName("Type").setType(StringParam.class).build())
+				.append(new ParamBuilder().setId("help").setName("Help").setType(StringParam.class).build())
+				.append(new ParamBuilder().setId("flags").setName("Flags").setType(DecimalParam.class).build());
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/params/ParamBuilder.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 84)
@@ -2,4 +2,6 @@
 
 import com.framsticks.params.types.*;
+import com.framsticks.util.lang.Numbers;
+
 import org.apache.log4j.Logger;
 
@@ -9,5 +11,5 @@
 /**
  * The class ParamBuilder helps building Param objects.
- * 
+ *
  * @author Mateusz Jarus <name.surname@gmail.com> (please replace name and
  *         surname with my personal data)
@@ -17,5 +19,5 @@
 
 public class ParamBuilder {
-	private final static Logger LOGGER = Logger.getLogger(ParamBuilder.class.getName());
+	private final static Logger log = Logger.getLogger(ParamBuilder.class.getName());
 
 	private static final String ID_FIELD = "id";
@@ -48,12 +50,12 @@
 
 	/** The getType of parameter. */
-	@SuppressWarnings("rawtypes")
-	private Class paramType;
+	private Class<? extends Param> paramType;
 
 	private Param param;
+	private PrimitiveParam primitiveParam;
 
 	/**
 	 * Build Param based on provided data.
-	 * 
+	 *
 	 * @return Param object
 	 * @throws Exception
@@ -61,5 +63,5 @@
 	 */
 	public Param build()  {
-        assert param != null;
+		assert param != null;
 		param.id = id;
 		param.name = name;
@@ -68,5 +70,4 @@
 		param.flags = flags;
 		param.internalId = internalId;
-
 		return param;
 	}
@@ -77,8 +78,16 @@
 	}
 
+	protected <T extends Param> ParamBuilder internalSetType(Class<? extends Param> type, T param) {
+		this.paramType = type;
+		this.param = param;
+		if (param instanceof PrimitiveParam) {
+			primitiveParam = (PrimitiveParam) param;
+		}
+		return this;
+	}
+
 	public <T extends Param> ParamBuilder setType(Class<T> type) {
-		this.paramType = type;
 		try {
-			this.param = (Param)paramType.newInstance();
+			return internalSetType(type, type.newInstance());
 		} catch (InstantiationException e) {
 			e.printStackTrace();
@@ -89,8 +98,6 @@
 	}
 
-	public <T extends Param> ParamBuilder setType(T type) {
-		this.paramType = type.getClass();
-		this.param = type;
-		return this;
+	public <T extends Param> ParamBuilder setType(T param) {
+		return internalSetType(param.getClass(), param);
 	}
 
@@ -116,7 +123,26 @@
 	}
 
+	protected <T extends Number> void parseMinMaxDefNumber(Class<T> type, String second, String third) {
+		if (primitiveParam == null) {
+			log.warn("param is not a primitive param");
+			return;
+		}
+		if (second != null) {
+			this.primitiveParam.min = Numbers.parse(second, type);
+			if (this.primitiveParam.min == null) {
+				log.warn("value of min attribute was invalid");
+			}
+		}
+		if (third != null) {
+			this.primitiveParam.max = Numbers.parse(third, type);
+			if (this.primitiveParam.max == null) {
+				log.warn("value of min attribute was invalid");
+			}
+		}
+	}
+
 	public ParamBuilder setType(String type) {
 
-		LOGGER.trace("parsing type: " + type);
+		log.trace("parsing type: " + type);
 
 		String[] typeSplitted = type.split(" ");
@@ -136,5 +162,5 @@
 					procedureParam.parseSignature(signature);
 				} catch (Exception e) {
-					LOGGER.error("invalid procedure signature '" + signature + "': " + e);
+					log.error("invalid procedure signature '" + signature + "': " + e);
 				}
 				setType(procedureParam);
@@ -148,5 +174,5 @@
 				} else {
 					if (first.length() >= 2) {
-						switch (first.charAt(1)) {
+				switch (first.charAt(1)) {
 							case 'b': {
 								setType(BinaryParam.class);
@@ -159,7 +185,7 @@
 						}
 					}
-                    if ("0".equals(second) && "1".equals(third)) {
-                        setType(BooleanParam.class);
-                    }
+					if ("0".equals(second) && "1".equals(third)) {
+						setType(BooleanParam.class);
+					}
 					if (param == null) {
 						setType(DecimalParam.class);
@@ -167,15 +193,5 @@
 				}
 				if (this.param instanceof DecimalParam) {
-					try {
-						if (second != null) {
-							this.param.min = Integer.parseInt(second);
-						}
-
-						if (third != null) {
-							this.param.max = Integer.parseInt(third);
-						}
-					} catch (NumberFormatException e) {
-						LOGGER.warn("value of min or max attribute should be an Integer");
-					}
+					parseMinMaxDefNumber(Integer.class, second, third);
 				}
 				break;
@@ -183,15 +199,5 @@
 			case 'f': {
 				setType(FloatParam.class);
-				try {
-					if (second != null) {
-						this.param.min = Double.parseDouble(second);
-					}
-
-					if (third != null) {
-						this.param.max = Double.parseDouble(third);
-					}
-				} catch (NumberFormatException ex) {
-					LOGGER.warn("Value of min or max attribute should be Double");
-				}
+				parseMinMaxDefNumber(Double.class, second, third);
 				break;
 			}
@@ -202,6 +208,6 @@
 			case 's': {
 				setType(StringParam.class);
-				this.param.min = second;
-				this.param.max = third;
+				setMin(second);
+				setMax(third);
 				break;
 			}
@@ -211,5 +217,4 @@
 			}
 			case 'l': {
-
 				setType(third != null ? new UniqueListParam(second, third) : new ArrayListParam(second));
 				break;
@@ -225,17 +230,35 @@
 	}
 
+	/**
+	 * @return the paramType
+	 */
+	public Class<? extends Param> getParamType() {
+		return paramType;
+	}
+
 	public <T> ParamBuilder setMin(T min) {
-		this.param.min = min;
+		if (primitiveParam != null) {
+			this.primitiveParam.min = min;
+		}
 		return this;
 	}
 
 	public <T> ParamBuilder setMax(T max) {
-		this.param.max = max;
+		if (primitiveParam != null) {
+			this.primitiveParam.max = max;
+		}
 		return this;
 	}
 
 	public <T> ParamBuilder setDef(T def) {
-		this.param.def = def;
-		return this;
+		if (def != null && primitiveParam != null) {
+			this.primitiveParam.def = def;
+		}
+		return this;
+	}
+
+	public Class<?> getStorageType() {
+		assert param != null;
+		return param.getStorageType();
 	}
 
@@ -244,5 +267,5 @@
 
 		if (paramEntryValues.length == 0) {
-			LOGGER.warn("field empty or wrong format (" + line
+			log.warn("field empty or wrong format (" + line
 					+ ") - omitting");
 			return null;
@@ -263,5 +286,5 @@
 			/** everything is ok, parameters have just finished*/
 		} catch (NumberFormatException ex) {
-			LOGGER.warn("wrong format of entry: " + line
+			log.warn("wrong format of entry: " + line
 					+ ", omitting");
 			return null;
Index: java/main/src/main/java/com/framsticks/params/PrimitiveParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/PrimitiveParam.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/params/PrimitiveParam.java	(revision 84)
@@ -0,0 +1,69 @@
+package com.framsticks.params;
+
+
+/**
+ * @author Piotr Sniegowski
+ */
+public abstract class PrimitiveParam extends ValueParam {
+
+	/** The minimum allowed value of parameter. */
+	protected Object min;
+
+	/** The maximum allowed value of parameter. */
+	protected Object max;
+
+	/** The default value of parameter. */
+	protected Object def;
+
+	public void save(SinkInterface sink, Object value) {
+		sink.print(value);
+	}
+
+	protected <T> T tryCastAndReturn(Object value, Class<T> type) {
+		if (value == null)
+			return null;
+		try {
+			return type.cast(value);
+		} catch (ClassCastException e) {
+			throw new ClassCastException("property \"" + name
+					+ "\" type is \"" + value.getClass().getName()
+					+ "\", not \"" + type.getName() + "\"");
+		}
+	}
+
+	/**
+	 * Gets the minimum value of parameter.
+	 *
+	 * @param <T> the generic getType which must be correctly specified by user
+	 * @param type the getType of variable, can be checked by
+	 * @return the minimum allowed value of parameter
+	 * @throws ClassCastException the class cast exception, thrown when given getType is incorrect
+	 */
+	public <T> T getMin(Class<T> type) {
+		return tryCastAndReturn(min, type);
+	}
+
+	/**
+	 * Gets the maximum value of parameter.
+	 *
+	 * @param <T> the generic getType which must be correctly specified by user
+	 * @param type the getType of variable, can be checked by {@link #getStorageType()}
+	 * @return the maximum allowed value of parameter
+	 * @throws ClassCastException the class cast exception, thrown when given getType is incorrect
+	 */
+	public <T> T getMax(Class<T> type) {
+		return tryCastAndReturn(max, type);
+	}
+
+	/**
+	 * Gets the default value of parameter.
+	 *
+	 * @param <T> the generic getType which must be correctly specified by user
+	 * @param type the getType of variable, can be checked by {@link #getStorageType()}
+	 * @return the default value of parameter
+	 * @throws ClassCastException the class cast exception, thrown when given getType is incorrect
+	 */
+	public <T> T getDef(Class<T> type) throws ClassCastException {
+		return tryCastAndReturn(def, type);
+	}
+}
Index: java/main/src/main/java/com/framsticks/params/PropertiesAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 84)
@@ -1,12 +1,11 @@
 package com.framsticks.params;
 
-import java.util.ArrayList;
 import java.util.HashMap;
-import java.util.List;
 import java.util.Map;
+
 
 /**
  * The Class PropertiesAccess.
- * 
+ *
  * @author Jarek Szymczak <name.surname@gmail.com> (please replace name and
  *         surname with my personal data)
@@ -18,5 +17,5 @@
 	public Map<String, Object> properties;
 
-    @Override
+	@Override
 	public Map<String, Object> createAccessee() {
 		return PropertiesAccess.createPropertiesMap();
@@ -33,12 +32,12 @@
 	@Override
 	public void clearValues() {
-        assert properties != null;
-        properties.clear();
+		assert properties != null;
+		properties.clear();
 	}
 
 	@Override
-	public <T> T get(Param param, Class<T> type) {
-        assert properties != null;
-        assert param != null;
+	public <T> T get(ValueParam param, Class<T> type) {
+		assert properties != null;
+		assert param != null;
 		Object object = null;
 		try {
@@ -54,5 +53,6 @@
 	}
 
-	protected <T> void internalSet(Param param, T value) {
+	@Override
+	protected <T> void internalSet(ValueParam param, T value) {
 		properties.put(param.getId(), value);
 	}
@@ -63,11 +63,13 @@
 	 * correct exceptions might occurred while getting / setting the parameters
 	 * values
-	 * 
+	 *
 	 * @param object
 	 *            the properties with parameters values
 	 */
+	@SuppressWarnings("unchecked")
 	@Override
-	public void select(Object object) {
+	public PropertiesAccess select(Object object) {
 		this.properties = (Map<String, Object>)object;
+		return this;
 	}
 
@@ -81,6 +83,4 @@
 	public PropertiesAccess cloneAccess() {
 		return new PropertiesAccess(framsClass);
-		//properties = createProperties();
-		//return access;
 	}
 
Index: java/main/src/main/java/com/framsticks/params/ReassignResult.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ReassignResult.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/params/ReassignResult.java	(revision 84)
@@ -0,0 +1,42 @@
+package com.framsticks.params;
+
+public class ReassignResult<T> {
+	protected final T value;
+	protected final int flags;
+
+	/**
+	 * @param value
+	 * @param state
+	 */
+	public ReassignResult(T value, int state) {
+		this.value = value;
+		this.flags = state;
+	}
+
+	/**
+	 * @param value
+	 */
+	public ReassignResult(T value) {
+		this.value = value;
+		this.flags = 0;
+	}
+
+	/**
+	 * @return the value
+	 */
+	public final T getValue() {
+		return value;
+	}
+
+	/**
+	 * @return the state
+	 */
+	public final int getFlags() {
+		return flags;
+	}
+
+	public static <T> ReassignResult<T> create(T value) {
+		return new ReassignResult<T>(value);
+	}
+
+}
